Global("BuffInternal", mainForm:GetChildChecked("BuffInternal", false))
Global("BuffPanel", mainForm:GetChildChecked("BuffPanel", false))
Global("DebuffPanel", mainForm:GetChildChecked("DebuffPanel", false))
Global("Drag1", BuffPanel:GetChildChecked("DragPanel", false))
Global("Drag2", DebuffPanel:GetChildChecked("DragPanel", false))
Global("BuffDesc", BuffInternal:GetWidgetDesc())
Global("Buff", {})
Global("Debuff", {})
Global("DTT", userMods.GetGlobalConfigSection("DTT"))
Global("TablePosition", 1)
Global("L", {
	["eng"] = {
		["Buff"] = "Buff Color",
		["Debuff"] = "Debuff Color",
		["StackCol"] = "Stack Color",
		["NameCol"] = "Name Color",
		["BuffTCol"] = "Buff Timer Color",
		["Background"] = "Background Color",
		["StackSize"] = "Stack Size",
		["NameSize"] = "Name Size",
		["BuffTSize"] = "Buff Timer Size",
		["SizeY"] = "Buff Size Y",
		["BNameShow"] = "Buff Name Show",
		["NameShow"] = "Name Show",
		["BuffShow"] = "Buff Show",
		["DebuffShow"] = "Debuff Show",
		["C2T"] = "Click to Target",
		["Ignore"] = "Ignore",
		["IgnoreL"] = "Ignore List",
	},
	
	["rus"] = {
		["Buff"] = "Buff Color",
		["Debuff"] = "Debuff Color",
		["StackCol"] = "Stack Color",
		["NameCol"] = "Name Color",
		["BuffTCol"] = "Buff Timer Color",
		["Background"] = "Background Color",
		["StackSize"] = "Stack Size",
		["NameSize"] = "Name Size",
		["BuffTSize"] = "Buff Timer Size",
		["SizeY"] = "Buff Size Y",
		["BNameShow"] = "Buff Name Show",
		["NameShow"] = "Name Show",
		["BuffShow"] = "Buff Show",
		["DebuffShow"] = "Debuff Show",
		["C2T"] = "Click to Target",
		["Ignore"] = "Ignore",
		["IgnoreL"] = "Ignore List",
	},
	
	["ger"] = {
		["Buff"] = "Buff Color",
		["Debuff"] = "Debuff Color",
		["StackCol"] = "Stack Color",
		["NameCol"] = "Name Color",
		["BuffTCol"] = "Buff Timer Color",
		["Background"] = "Background Color",
		["StackSize"] = "Stack Size",
		["NameSize"] = "Name Size",
		["BuffTSize"] = "Buff Timer Size",
		["SizeY"] = "Buff Size Y",
		["BNameShow"] = "Buff Name Show",
		["NameShow"] = "Name Show",
		["BuffShow"] = "Buff Show",
		["DebuffShow"] = "Debuff Show",
		["C2T"] = "Click to Target",
		["Ignore"] = "Ignore",
		["IgnoreL"] = "Ignore List",
	},
	
	["fra"] = {
		["Buff"] = "Buff Color",
		["Debuff"] = "Debuff Color",
		["StackCol"] = "Stack Color",
		["NameCol"] = "Name Color",
		["BuffTCol"] = "Buff Timer Color",
		["Background"] = "Background Color",
		["StackSize"] = "Stack Size",
		["NameSize"] = "Name Size",
		["BuffTSize"] = "Buff Timer Size",
		["SizeY"] = "Buff Size Y",
		["BNameShow"] = "Buff Name Show",
		["NameShow"] = "Name Show",
		["BuffShow"] = "Buff Show",
		["DebuffShow"] = "Debuff Show",
		["C2T"] = "Click to Target",
		["Ignore"] = "Ignore",
		["IgnoreL"] = "Ignore List",
	},
	
	["jpn"] = {
		["Buff"] = "Buff Color",
		["Debuff"] = "Debuff Color",
		["StackCol"] = "Stack Color",
		["NameCol"] = "Name Color",
		["BuffTCol"] = "Buff Timer Color",
		["Background"] = "Background Color",
		["StackSize"] = "Stack Size",
		["NameSize"] = "Name Size",
		["BuffTSize"] = "Buff Timer Size",
		["SizeY"] = "Buff Size Y",
		["BNameShow"] = "Buff Name Show",
		["NameShow"] = "Name Show",
		["BuffShow"] = "Buff Show",
		["DebuffShow"] = "Debuff Show",
		["C2T"] = "Click to Target",
		["Ignore"] = "Ignore",
		["IgnoreL"] = "Ignore List",
	},
	
	["br"] = {
		["Buff"] = "Buff Color",
		["Debuff"] = "Debuff Color",
		["StackCol"] = "Stack Color",
		["NameCol"] = "Name Color",
		["BuffTCol"] = "Buff Timer Color",
		["Background"] = "Background Color",
		["StackSize"] = "Stack Size",
		["NameSize"] = "Name Size",
		["BuffTSize"] = "Buff Timer Size",
		["SizeY"] = "Buff Size Y",
		["BNameShow"] = "Buff Name Show",
		["NameShow"] = "Name Show",
		["BuffShow"] = "Buff Show",
		["DebuffShow"] = "Debuff Show",
		["C2T"] = "Click to Target",
		["Ignore"] = "Ignore",
		["IgnoreL"] = "Ignore List",
	},
})
-------------------------------------------------------------------------------
-- FUNCTION
-------------------------------------------------------------------------------
function toHex(N) --Modified version of someone else's free source C code. CREATES HEX FROM RGBA (should rewrite it to concat R..G..B..A internally)
	if N==nil then
		return "00"
	elseif N==0 then 
		return "00"
	else
		N=math.max(0,N)
		N=math.min(N,255)
		N=math.ceil(N)
		return string.sub("0123456789ABCDEF", 1 + (N- (N - math.floor(N/16)*16))/16, 1 + (N- (N - math.floor(N/16)*16))/16)..string.sub("0123456789ABCDEF", 1 + (N - math.floor(N/16)*16), 1 + (N - math.floor(N/16)*16))
	end
end

function DebuffChanged(p)
	if p.objects then
		p.units = p.objects
	end
	for i, v in p.units do
		if unit.GetBuffCount(i) then
			local P = {unitId = i}
			Buffs(P)
		end
	end
end
	
function Buffs(p)
	if p.objectId then
		p.unitId = p.objectId
	end
	local buffscount = 0
	local debuffscount = 0
	
	DestroyBuff(Buff, p)
	DestroyBuff(Debuff, p)
	
	local buffcount = unit.GetBuffCount(p.unitId)
	if buffcount then
		for i = 0, buffcount - 1 do
			local buffs = unit.GetBuff(p.unitId, i)
			local showBuff = true
			for i, v in DTT["Ignore"] do
				if string.lower(userMods.FromWString(buffs.name)) == v then
					showBuff = false
				end
			end
			if showBuff then
				if buffs.producer.casterId == avatar.GetId() then
					if buffs.isPositive == true and DTT["BuffShow"] then
						BuffCreate(p, buffs, Buff, buffscount, BuffPanel, "Buff")
						buffscount = buffscount + 1
						SortBuffs(Buff)
					elseif buffs.isPositive == false and DTT["DebuffShow"] then
						BuffCreate(p, buffs, Debuff, debuffscount, DebuffPanel, "Debuff")
						debuffscount = debuffscount + 1
						SortBuffs(Debuff)
					end
				end
			end
		end
	end
end

function DestroyBuff(owner, p)
	if owner[p.unitId] then
		for i, v in owner[p.unitId] do
			if v then
				v:DestroyWidget()
			end
		end
		owner[p.unitId] = nil
	end
	if not owner[p.unitId] then
		owner[p.unitId] = {}
	end
end

function BuffCreate(p, buffs, owner, count, panel, color)
	owner[p.unitId][count] = mainForm:CreateWidgetByDesc(BuffDesc)
	owner[p.unitId][count]:GetChildChecked("C2T", false):Show(DTT["C2T"])
	owner[p.unitId][count]:GetChildChecked("C2T", false):SetName(""..p.unitId)
	owner[p.unitId][count]:SetBackgroundColor(DTT["Background"])
	owner[p.unitId][count]:GetChildChecked("Bar", false):SetBackgroundColor(DTT[color])
	if buffs.texture then
		owner[p.unitId][count]:GetChildChecked("Texture", false):SetBackgroundTexture(buffs.texture)
		local P = owner[p.unitId][count]:GetChildChecked("Texture", false):GetPlacementPlain()
		P.sizeX = DTT["SizeY"]
		owner[p.unitId][count]:GetChildChecked("Texture", false):SetPlacementPlain(P)
	end
	if buffs.isStackable and buffs.stackCount > 1 then
		owner[p.unitId][count]:GetChildChecked("Stack", false):SetFormat(userMods.ToWString("<html color='0x"..toHex(DTT["StackCol"].a*255)..toHex(DTT["StackCol"].r*255)..toHex(DTT["StackCol"].g*255)..toHex(DTT["StackCol"].b*255).."' fontsize='"..DTT["StackSize"].."' outline='1'><r name='stack'/></html>"))
		owner[p.unitId][count]:GetChildChecked("Stack", false):SetVal("stack", common.FormatInt(buffs.stackCount, "%d"))
	end
	local msg = ""
	if DTT["BNameShow"] then
		msg = msg..userMods.FromWString(buffs.name).." "
	end
	if DTT["NameShow"] and object.IsExist(p.unitId) and object.GetName(p.unitId) then
		msg = msg.."("..userMods.FromWString(object.GetName(p.unitId))..")"
	end
	if msg ~= "" then
		local P = owner[p.unitId][count]:GetChildChecked("Name", false):GetPlacementPlain()
		P.posX = DTT["SizeY"]
		owner[p.unitId][count]:GetChildChecked("Name", false):SetPlacementPlain(P)
		owner[p.unitId][count]:GetChildChecked("Name", false):SetFormat(userMods.ToWString("<html color='0x"..toHex(DTT["NameCol"].a*255)..toHex(DTT["NameCol"].r*255)..toHex(DTT["NameCol"].g*255)..toHex(DTT["NameCol"].b*255).."' fontsize='"..DTT["NameSize"].."' outline='1'><r name='name'/></html>"))
		owner[p.unitId][count]:GetChildChecked("Name", false):SetVal("name", userMods.ToWString(msg))
	end
	if buffs.durationMs > 0 and buffs.remainingMs > 0 then
		local times = math.ceil( buffs.remainingMs / 1000 )
		local timetype = "s"
		if times >= 60 then
			times = math.ceil( times / 60 )
			timetype = "m"
			if times >= 60 then
				times = math.ceil( times / 60 )
				timetype = "h"
			end
		end
		owner[p.unitId][count]:GetChildChecked("BuffTimer", false):SetFormat(userMods.ToWString("<header color='0x"..toHex(DTT["BuffTCol"].a*255)..toHex(DTT["BuffTCol"].r*255)..toHex(DTT["BuffTCol"].g*255)..toHex(DTT["BuffTCol"].b*255).."' fontsize='"..DTT["BuffTSize"].."' outline='1'><r name='timer'/></header>"))
		owner[p.unitId][count]:GetChildChecked("BuffTimer", false):SetVal("timer", userMods.ToWString(times.." "..timetype))
		local fromPlacement = owner[p.unitId][count]:GetChildChecked("Bar", false):GetPlacementPlain()
		fromPlacement.sizeX = 180 * (buffs.remainingMs/buffs.durationMs)
		local toPlacement = owner[p.unitId][count]:GetChildChecked("Bar", false):GetPlacementPlain()
		toPlacement.sizeX = 0
		owner[p.unitId][count]:GetChildChecked("Bar", false):PlayResizeEffect( fromPlacement, toPlacement, buffs.remainingMs, EA_MONOTONOUS_INCREASE )
	elseif buffs.isStackable then
		local Placement = owner[p.unitId][count]:GetChildChecked("Bar", false):GetPlacementPlain()
		if buffs.stackLimit > 1 then
			Placement.sizeX = 180 - (180 * (buffs.stackCount/buffs.stackLimit))
		else
			Placement.sizeX = 180
		end
		owner[p.unitId][count]:GetChildChecked("Bar", false):SetPlacementPlain(Placement)
	end
	panel:AddChild(owner[p.unitId][count])
	owner[p.unitId][count]:Show(true)
end

function DeadChanged(p)
	if Buff[p.unitId] then
		for i, v in Buff[p.unitId] do
			v:DestroyWidget()
		end
		Buff[p.unitId] = nil
	end
	if Debuff[p.unitId] then
		for i, v in Debuff[p.unitId] do
			v:DestroyWidget()
		end
		Debuff[p.unitId] = nil
	end
end

function ZoneChanged()
	for i, v in Buff do
		if i and object.IsExist(i) then
		else
			local p = {unitId = i}
			DeadChanged(p)
		end
	end
	for i, v in Debuff do
		if i and object.IsExist(i) then
		else
			local p = {unitId = i}
			DeadChanged(p)
		end
	end
end

function SortBuffs(p)
	local num = 0
	for i, v in p do
		if v then
			for j, x in v do
				if x and x:IsVisible() then
					local P = x:GetPlacementPlain()
					P.sizeY = DTT["SizeY"]
					P.posY = (DTT["SizeY"] * num)
					x:SetPlacementPlain(P)
					num = num + 1
				end
			end
		end
	end
end

function Slash(p)
	if userMods.FromWString(p.text) == "/dttdnd" then
		Drag1:Show(not Drag1:IsVisible())
		Drag2:Show(not Drag2:IsVisible())
	end
end

function Click(r)
	if object.IsExist(tonumber(r.sender)) then
		avatar.SelectTarget(tonumber(r.sender))
	end
end

-- AO game Localization detection by SLA. Version 2011-02-05.
function GetGameLocalization()
	local B = cartographer.GetMapBlocks()
	local T = { rus="\203\232\227\224", eng="Holy Land",
	ger="Heiliges Land", fra="Terre Sacr\233e", br="Terra Sagrada", jpn="\131\74\131\106\131\65" }
	for b in B do for l,t in T do
	if userMods.FromWString( cartographer.GetMapBlockInfo(B [b] ).name ) == t
	then return l end; end end; return "eng"
end

--ADDON MANAGER COOPERATION
function OnEventAMMemUsageRequest() --MEMORY
	userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

function OnScriptToggleUI( params ) --UI TOGGLE
	mainForm:Show( params.visible )
end

--CONFIG WINDOW COOPERATION
function ConfigInitEvent()
	userMods.SendEvent("CONFIG_INIT_EVENT_RESPONSE", { sender = common.GetAddonName() })
end

function ConfigEvent()
	local t = L[GetGameLocalization()]
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 0, name = "DnD", btnType = "Simple"})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 1, name = t["Buff"], btnType = "Color", color = DTT["Buff"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 2, name = t["Debuff"], btnType = "Color", color = DTT["Debuff"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 3, name = t["StackCol"], btnType = "Color", color = DTT["StackCol"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 4, name = t["NameCol"], btnType = "Color", color = DTT["NameCol"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 5, name = t["BuffTCol"], btnType = "Color", color = DTT["BuffTCol"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 6, name = t["Background"], btnType = "Color", color = DTT["Background"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 7, name = t["StackSize"], btnType = "EditLine", value = DTT["StackSize"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 8, name = t["NameSize"], btnType = "EditLine", value = DTT["NameSize"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 9, name = t["BuffTSize"], btnType = "EditLine", value = DTT["BuffTSize"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 10, name = t["SizeY"], btnType = "EditLine", value = DTT["SizeY"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 11, name = t["BNameShow"], btnType = "T/F", state = DTT["BNameShow"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 12, name = t["NameShow"], btnType = "T/F", state = DTT["NameShow"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 13, name = t["BuffShow"], btnType = "T/F", state = DTT["BuffShow"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 14, name = t["DebuffShow"], btnType = "T/F", state = DTT["DebuffShow"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 15, name = t["C2T"], btnType = "T/F", state = DTT["C2T"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 16, name = t["Ignore"], btnType = "EditLine"})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 17, name = t["IgnoreL"], btnType = "Tabled", text = DTT["Ignore"][1], scale = .7})
end

function ConfigSimple(p)
	Drag1:Show(not Drag1:IsVisible())
	Drag2:Show(not Drag2:IsVisible())
end

function ConfigColor(p)
	local t = L[GetGameLocalization()]
	for i, v in t do
		if v == p.name then
			DTT[i] = p.color
		end
	end
	userMods.SetGlobalConfigSection("DTT", DTT)
end

function ConfigTF(p)
	local t = L[GetGameLocalization()]
	for i, v in t do
		if v == p.name then
			DTT[i] = p.state
		end
	end
	userMods.SetGlobalConfigSection("DTT", DTT)
end

function ConfigEL(p)
	local t = L[GetGameLocalization()]
	if p.name == t["Ignore"] then
		local ignoreExists
		for i, v in DTT["Ignore"] do
			if string.lower(p.text) == v then
				ignoreExists = i
			end
		end
		if ignoreExists then
			table.remove(DTT["Ignore"], ignoreExists)
		else
			table.insert(DTT["Ignore"], string.lower(p.text))
		end
		userMods.SetGlobalConfigSection("DTT", DTT)
	elseif tonumber(p.text) ~= nil then
		for i, v in t do
			if v == p.name then
				DTT[i] = tonumber(p.text)
			end
		end
		local num = 7
		if p.name == t["NameSize"] then
			num = 8
		elseif p.name == t["BuffTSize"] then
			num = 9
		elseif p.name == t["SizeY"] then
			num = 10
		end
		userMods.SendEvent("CONFIG_CHANGE_BUTTON_RESPONSE", {NoB = num, name = p.name, value = p.text})
		userMods.SetGlobalConfigSection("DTT", DTT)
	end
end

function ConfigTabled(p)
	local t = L[GetGameLocalization()]
	if p.dir == "+" then
		TablePosition = TablePosition + 1
	elseif p.dir == "-" then
		TablePosition = TablePosition - 1
	end
	local num = 0
	for i, v in DTT["Ignore"] do
		num = num + 1
	end
	if DTT["Ignore"][TablePosition] then
	elseif TablePosition > 1 then
		TablePosition = 1
	elseif TablePosition < 1 then
		TablePosition = num
	end
	userMods.SendEvent("CONFIG_CHANGE_BUTTON_RESPONSE", {NoB = 17, name = t["IgnoreL"], text = DTT["Ignore"][TablePosition], scale = .7})
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	if not DTT then
		DTT = {}
		DTT["Buff"] = {r=0;b=0;g=.7;a=.7}
		DTT["Debuff"] = {r=.7;b=0;g=0;a=.7}
		DTT["Background"] = {r=0;b=0;g=0;a=.3}
		DTT["StackCol"] = {r=.6;b=.6;g=.6;a=1}
		DTT["NameCol"] = {r=.6;b=.6;g=.6;a=1}
		DTT["BuffTCol"] = {r=.6;b=.6;g=.6;a=1}
		DTT["StackSize"] = 11
		DTT["NameSize"] = 12
		DTT["BuffTSize"] = 12
		DTT["SizeY"] = 20
		DTT["BNameShow"] = true
		DTT["NameShow"] = false
		DTT["BuffShow"] = true
		DTT["DebuffShow"] = true
	end
	if DTT["C2T"] == nil then
		DTT["C2T"] = false
	end
	if DTT["Ignore"] == nil then
		DTT["Ignore"] = {"nil",}
	end
	userMods.SetGlobalConfigSection("DTT", DTT)
	common.RegisterEventHandler( DebuffChanged, "EVENT_UNIT_BUFFS_ELEMENT_CHANGED" )
	common.RegisterEventHandler( DebuffChanged, "EVENT_OBJECT_BUFFS_ELEMENT_CHANGED")
	common.RegisterEventHandler( Buffs, "EVENT_UNIT_BUFF_ADDED" )
	common.RegisterEventHandler( Buffs, "EVENT_UNIT_BUFFS_CHANGED" )
	common.RegisterEventHandler( Buffs, "EVENT_OBJECT_BUFF_ADDED")
	common.RegisterEventHandler( Buffs, "EVENT_OBJECT_BUFFS_CHANGED" )
	common.RegisterEventHandler( DeadChanged, "EVENT_UNIT_DESPAWNED" )
	common.RegisterEventHandler( DeadChanged, "EVENT_UNIT_DEAD_CHANGED" )
	common.RegisterEventHandler( ZoneChanged, "EVENT_AVATAR_ZONE_CHANGED" )
	common.RegisterEventHandler( Slash, "EVENT_UNKNOWN_SLASH_COMMAND" )
	common.RegisterReactionHandler( Click, "C2T" )
	-- ADDON MANAGER EVENTS (MEMORY, DND TOGGLE, UI TOGGLE)
	common.RegisterEventHandler( OnEventAMMemUsageRequest, "U_EVENT_ADDON_MEM_USAGE_REQUEST" )
	common.RegisterEventHandler( OnScriptToggleUI, "SCRIPT_TOGGLE_UI" )
	--CONFIG WINDOW EVENTS (INIT, EVENT, COLOR, SIMPLE, TF, EDIT, TABLED)
	common.RegisterEventHandler( ConfigInitEvent, "CONFIG_INIT_EVENT" )
	common.RegisterEventHandler( ConfigEvent, "CONFIG_EVENT_"..common.GetAddonName())
	common.RegisterEventHandler( ConfigColor, "CONFIG_COLOR_"..common.GetAddonName())
	common.RegisterEventHandler( ConfigSimple, "CONFIG_SIMPLE_"..common.GetAddonName())
	common.RegisterEventHandler( ConfigTF, "CONFIG_BUTTON_"..common.GetAddonName())
	common.RegisterEventHandler( ConfigEL, "CONFIG_EDIT_LINE_"..common.GetAddonName())
	common.RegisterEventHandler( ConfigTabled, "CONFIG_TABLED_"..common.GetAddonName())
	DnD:Init(1055, Drag1, BuffPanel, true)
	DnD:Init(1056, Drag2, DebuffPanel, true)
end
--------------------------------------------------------------------------------
common.RegisterEventHandler( Init, "EVENT_AVATAR_CREATED")
if avatar.IsExist() then
Init()
end
--------------------------------------------------------------------------------